"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = require("path");
const nunjucks_1 = require("nunjucks");
const to_curl_1 = require("./to-curl");
const defaultTemplatesDir = path_1.join(__dirname, '..', 'templates');
const cleanupMarkdown = (input) => {
    const trailingSpaces = / +\n/g;
    const excessiveNewLines = /\n{3,}/g;
    if (!input) {
        return input;
    }
    let result = input.replace(trailingSpaces, '\n');
    result = result.replace(excessiveNewLines, '\n\n');
    return result;
};
const toMarkdown = async (title, baseUri, resource) => {
    const template = path_1.join(defaultTemplatesDir, 'resources.nunjucks');
    nunjucks_1.installJinjaCompat();
    const env = nunjucks_1.configure(defaultTemplatesDir, { autoescape: false })
        .addGlobal('baseURI', baseUri)
        .addGlobal('getCurlStatement', to_curl_1.default);
    const result = await env.render(template, { title, baseUri, resource });
    return cleanupMarkdown(result);
};
exports.default = toMarkdown;
